var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import { TreeNode } from './TreeNode';
var DragSource = (function () {
    function DragSource() {
        this.tree = new TreeNode({
            componentName: 'SourceRoot',
        });
    }
    DragSource.prototype.setSourcesByGroup = function (group, sources) {
        var parent = this.tree.findById(group);
        var nodes = sources.map(function (node) { return new TreeNode(node); });
        if (parent) {
            parent.setNodeChildren.apply(parent, __spread(nodes));
        }
        else {
            var newParent = new TreeNode({
                componentName: 'SourceGroup',
                id: group,
            });
            newParent.setNodeChildren.apply(newParent, __spread(nodes));
            this.tree.appendNode(newParent);
        }
    };
    DragSource.prototype.getSourcesByGroup = function (group) {
        var parent = this.tree.findById(group);
        return parent === null || parent === void 0 ? void 0 : parent.children;
    };
    DragSource.prototype.mapSourcesByGroup = function (group, callback) {
        var _a;
        var sources = this.getSourcesByGroup(group);
        return (_a = sources === null || sources === void 0 ? void 0 : sources.map) === null || _a === void 0 ? void 0 : _a.call(sources, callback);
    };
    DragSource.prototype.eachSourcesByGroup = function (group, callback) {
        var _a;
        var sources = this.getSourcesByGroup(group);
        return (_a = sources === null || sources === void 0 ? void 0 : sources.forEach) === null || _a === void 0 ? void 0 : _a.call(sources, callback);
    };
    DragSource.prototype.reduceSourcesByGroup = function (id, callback, init) {
        var _a;
        var sources = this.getSourcesByGroup(id);
        return (_a = sources === null || sources === void 0 ? void 0 : sources.reduce) === null || _a === void 0 ? void 0 : _a.call(sources, callback, init);
    };
    return DragSource;
}());
export { DragSource };
export var GlobalDragSource = new DragSource();
