/// <reference types="react" />
import { JSONSchema7Type, JSONSchema7TypeName, JSONSchema7Version } from 'json-schema';
export declare type JSONSchema7Definition = JSONSchema7 | boolean;
export interface JSONSchema7 {
    $id?: string;
    $ref?: string;
    $schema?: JSONSchema7Version;
    $comment?: string;
    type?: JSONSchema7TypeName | JSONSchema7TypeName[];
    enum?: JSONSchema7Type[];
    const?: JSONSchema7Type;
    multipleOf?: number;
    maximum?: number;
    exclusiveMaximum?: number;
    minimum?: number;
    exclusiveMinimum?: number;
    maxLength?: number;
    minLength?: number;
    pattern?: string;
    items?: JSONSchema7Definition | JSONSchema7Definition[];
    additionalItems?: JSONSchema7Definition;
    maxItems?: number;
    minItems?: number;
    uniqueItems?: boolean;
    contains?: JSONSchema7;
    maxProperties?: number;
    minProperties?: number;
    required?: string[];
    properties?: {
        [key: string]: JSONSchema7Definition;
    };
    patternProperties?: {
        [key: string]: JSONSchema7Definition;
    };
    additionalProperties?: JSONSchema7Definition;
    dependencies?: {
        [key: string]: JSONSchema7Definition | string[];
    };
    propertyNames?: JSONSchema7Definition;
    if?: JSONSchema7Definition;
    then?: JSONSchema7Definition;
    else?: JSONSchema7Definition;
    allOf?: JSONSchema7Definition[];
    anyOf?: JSONSchema7Definition[];
    oneOf?: JSONSchema7Definition[];
    not?: JSONSchema7Definition;
    format?: string;
    contentMediaType?: string;
    contentEncoding?: string;
    definitions?: {
        [key: string]: JSONSchema7Definition;
    };
    title?: string | React.ReactNode;
    description?: string | React.ReactNode;
    default?: JSONSchema7Type;
    readOnly?: boolean;
    writeOnly?: boolean;
    examples?: JSONSchema7Type;
    [key: string]: any;
}
